SystemOrganization addCategory: #'Pier-JQueryMobile-Core'!

PRDistribution subclass: #PRJQueryMobileDistribution
	instanceVariableNames: 'headerNav sideNav parentLinks childrenLinks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJQueryMobileDistribution commentStamp: 'YanniChiu 12/8/2011 00:11' prior: 0!
A PRJQueryMobileDistribution is used to create an example Pier application using a JQueryMobile interface.
!

!PRJQueryMobileDistribution class methodsFor: 'accessing' stamp: 'YanniChiu 12/7/2011 13:35'!
register
	^ self new register! !

!PRJQueryMobileDistribution class methodsFor: 'accessing' stamp: 'YanniChiu 12/7/2011 13:36'!
title
	^'Default jQueryMobile'! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 18:27'!
blogEnvironmentPage
	^ blogEnvironmentPage ifNil: [
		blogEnvironmentPage := (PRPage named: 'blogenvironment')
		title: '_Blog Environment';
		contents: self mainEnvironmentPage contents;
		yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 18:24'!
childrenLinksPage
	^ childrenLinks ifNil: [
		childrenLinks := (PRPage named: 'childrenlinks')
			title: 'Children Link';
			contents: '*>value:children|link*';
			yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 23:58'!
commandsPage
	^ commandsPage ifNil: [
		commandsPage := (PRComponent named: 'commands') componentClass: PRJqmCommandsWidget; yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 23:12'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
			title: '_Environment';
			contents: self mainEnvironmentPage contents;
			yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 18:18'!
footerPage
	^ footerPage ifNil: [
		footerPage := (PRPage named: 'footer')
			title: 'Footer';
			contents: '!!!!!!+/system/components/poweredby+';
			yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 23:31'!
headerNavPage
	^ headerNav ifNil: [
		headerNav := (PRPage named: 'hnav')
			title: 'Header Navbar';
			contents:
'-*Home>/*
-*Blog>/blog*
-*About>/about*
';
			yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 18:18'!
headerPage
	^ headerPage ifNil: [
		headerPage := (PRPage named: 'header')
			title: 'Header';
			contents:
'{{{<div data-role="header">
<h1>}}}*value:structure*{{{</h1>}}}
+/system/components/authentication+
{{{</div>}}}';
			yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 23:55'!
loginCommandWidget
	^ loginCommandWidget ifNil: [
		loginCommandWidget := (PRComponent named: 'authentication') componentClass: PRAuthenticationWidget; yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 17:52'!
mainEnvironmentPage
	^ mainEnvironmentPage ifNil: [
		mainEnvironmentPage := (PRPage named: 'mainenvironment')
		title: '_Main Environment';
		contents: 
'
{{{<div class="type-interior">}}}
+/system/components/header+
+/system/components/hnav|jquerymobile=navbar+{{{
<div class="content-primary">}}}
+/system/components/contents+{{{
</div>
<div class="content-secondary">
<div data-role="collapsible">
<h3>Menu</h3>}}}
+/system/components/sidenav|jquerymobile=list+
+/system/components/commands+
+/system/components/views+{{{
</div>
</div>
<div data-role="footer">
}}}+/system/components/footer+{{{
</div>
</div>
}}}
';
		yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 18:31'!
metaEnvironmentPage
	^ metaEnvironmentPage ifNil: [
		metaEnvironmentPage := (PRPage named: 'metaenvironment')
		title: '_Meta Environment';
"		hideFromMenus: true;"
		contents: self mainEnvironmentPage contents;
		yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 18:24'!
parentLinksPage
	^ parentLinks ifNil: [
		parentLinks := (PRPage named: 'parentlinks')
			title: 'Parents Link';
			contents: '*>value:parents|link*';
			yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'creation' stamp: 'YanniChiu 12/8/2011 00:40'!
register 
	| application |
	PRKernel reset.
	application := PRJqmFrame 
		registerAsApplication: 'pier'
		kernel: self kernel.
	application removeLibrary: PRBlueprintLibrary.
	application addLibrary: PRJqmFileLibrary.
	application parent defaultName: 'pier'.! !

!PRJQueryMobileDistribution methodsFor: 'creation' stamp: 'YanniChiu 12/7/2011 18:23'!
root
	self rootPage
		addChild: self blog;
		addChild: (self aboutPage
				addChild: self syntaxPage;
				yourself);
		addChild: (self systemPage
			addChild: (self componentsPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuPage;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;
				addChild: self searchWidget;
				addChild: self poweredPage;
				addChild: self loggedInUserPage;
				addChild: self designChooserWidget;
				addChild: self documentWidget;
				addChild: self headerNavPage;
				addChild: self sideNavPage;
				addChild: self parentLinksPage;
				addChild: self childrenLinksPage;
				yourself);
			addChild: self systemManagementPage;
			addChild: (self templatesPage
				addChild: self environmentPage;
				addChild: self blogEnvironmentPage;
				addChild: self mainEnvironmentPage;
				addChild: self metaEnvironmentPage;
				yourself
			);
			yourself
		).
	self rootPage localEnvironment: self mainEnvironmentPage.
	self blog localEnvironment: self blogEnvironmentPage.
	self aboutPage localEnvironment: self environmentPage.
	self environmentPage localEnvironment: self metaEnvironmentPage.
	self mainEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self systemManagementPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	self rootPage enumerator
		with;
		all;
		do: [ :each | 
			each outgoingReferences 
				do: [ :link | (link isKindOf: PRInternalLink) ifTrue: [ link target: nil ] ].
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self systemPage.
	self makePrivate: self environmentPage.
	self makePrivate: self blogEnvironmentPage.
	self makePrivate: self mainEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
"	self makePublic: self sitemapPage." "Disabled because makePublic has the same implementation as makePrivate, added issue 134 on the public issue tracker for this."
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	self makePrivate: self loggedInUserPage.	
	"pier-sprint-eindhoven -http://forum.world.st/huge-security-problem-with-pier-td3241518.html".	
	self makePrivate: self designChooserWidget.
	^ self rootPage! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 23:31'!
sideNavPage
	^ sideNav ifNil: [
		sideNav := (PRPage named: 'sidenav')
			title: 'Side Navbar';
			contents:
'-*Site Map>/system/components/sitemap*
-Parent Links
+/system/components/parentlinks+
-Children Links
+/system/components/childrenlinks+
';
			yourself
	]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 23:37'!
stylesheetFile
	^ stylesheetFile ifNil: [
		stylesheetFile := (PRFile named: 'defaultCss')
		filename: 'style.css';
		mimetype: 'text/css';
		contents: 'p{}';
		yourself]! !

!PRJQueryMobileDistribution methodsFor: 'structures' stamp: 'YanniChiu 12/7/2011 23:58'!
viewsPage
	^ viewsPage ifNil: [
		viewsPage := (PRComponent named: 'views') componentClass: PRJqmViewsWidget; yourself
	]! !

!PRObject methodsFor: '*pier-jquerymobile-core' stamp: 'YanniChiu 12/8/2011 01:28'!
description
	^ super description
		componentRenderer: PRJqmFormRenderer;
		yourself! !

!WABasicFormTag methodsFor: '*pier-jquerymobile-core' stamp: 'YanniChiu 11/6/2011 00:00'!
jqmNoAjax: aBoolean
	aBoolean ifTrue: [ self jqmNoAjax ]! !

PRPierFrame subclass: #PRJqmFrame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmFrame commentStamp: 'YanniChiu 12/8/2011 00:40' prior: 0!
A PRJqmFrame is a PRPierFrame specialized for JQueryMobile.
!

!PRJqmFrame class methodsFor: 'registration' stamp: 'YanniChiu 10/20/2011 20:25'!
registerAsApplication: aString kernel: aKernel
	"self registerAsApplication: 'pier' kernel: (PRKernel instanceNamed: 'pier')"

	| app |
	app := JQMAdmin register: self asApplicationAt: aString.
	self configureApplication: app.
	app preferenceAt: #kernel put: aKernel.
	^ app! !

!PRJqmFrame methodsFor: 'updating' stamp: 'YanniChiu 11/4/2011 22:37'!
assignJqmTheme: s
	"Options from: http://stackoverflow.com/questions/4891906/jquery-mobile-default-data-theme"

	"Navigation"
	s << s jQuery mobile access: 'page.prototype.options.backBtnText'; assign: 'Go back'.
	s << s jQuery mobile access: 'page.prototype.options.addBackBtn'; assign: true.
	s << s jQuery mobile access: 'page.prototype.options.backBtnTheme'; assign: 'd'.
	"Page"
	s << s jQuery mobile access: 'page.prototype.options.headerTheme'; assign: 'a'.
	s << s jQuery mobile access: 'page.prototype.options.contentTheme'; assign: 'c'.
	s << s jQuery mobile access: 'page.prototype.options.footerTheme'; assign: 'a'.
	"List Views"
	s << s jQuery mobile access: 'listview.prototype.options.headerTheme'; assign: 'a'. "Header for nested lists"
	s << s jQuery mobile access: 'listview.prototype.options.theme'; assign: 'c'. "List items / content"
	s << s jQuery mobile access: 'listview.prototype.options.dividerTheme'; assign: 'd'. "List divider"

	s << s jQuery mobile access: 'listview.prototype.options.splitTheme'; assign: 'c'.
	s << s jQuery mobile access: 'listview.prototype.options.countTheme'; assign: 'c'.
	s << s jQuery mobile access: 'listview.prototype.options.filterTheme'; assign: 'c'.
	s << s jQuery mobile access: 'listview.prototype.options.filterPlaceholder'; assign: 'Filter data...'.
! !

!PRJqmFrame methodsFor: 'updating' stamp: 'YanniChiu 11/4/2011 22:37'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot mobileInit: [ :s |
		s << s jQuery mobile defaultPageTransition: 'none'.
		s << s jQuery mobile defaultDialogTransition: 'none'.
		"self assignJqmTheme: s."
	].
! !

WAFileLibrary subclass: #PRJqmFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmFileLibrary commentStamp: 'YanniChiu 12/8/2011 00:08' prior: 0!
A PRJqmFileLibrary is a file library that serves the custom CSS stylesheet for the JQueryMobile interface of Pier.
!

!PRJqmFileLibrary methodsFor: 'uploaded' stamp: 'YanniChiu 12/7/2011 14:03'!
prJQueryMobileCss
	^ '/* Pier jQuery Mobile CSS*/

.type-interior .content-secondary {
	border-right: 0;
	border-left: 0;
	margin: 10px -15px 0;
	border-top: 1px solid #ccc;
}
.type-interior .ui-content {
	padding-bottom: 0;
}
.content-secondary .ui-collapsible {
	padding: 0 15px 10px;

}
.content-secondary .ui-collapsible-content {
	padding: 0;
	background: none;
	border-bottom: none;
}
.content-secondary .ui-listview {
	margin: 0;
}
		
/* docs site layout */

@media all and (min-width: 650px){
	
	.type-interior .ui-content {
		padding: 0;
	}
	.type-interior .ui-content {
		background-position: 45%;
		overflow: hidden;
	}
	.content-secondary {
		text-align: left;
		float: left;
		width: 45%;
		background: none;
	}
	.content-secondary,
	.type-interior .content-secondary {
		margin: 30px 0 20px 2%;
		padding: 20px 4% 0 0;
		background: none;
		border-top: none;
	}
	.type-index .content-secondary {
		padding: 0;
	}
	.content-secondary .ui-collapsible {
		margin: 0;
		padding: 0;
	}
	.content-secondary .ui-collapsible-content {
		border: none;
	}
	.type-index .content-secondary .ui-listview {
		margin: 0;
	}

	.ui-mobile #jqm-homeheader {
		padding: 0;
	}
	.content-primary {
		width: 45%;
		float: right;
		margin-top: 30px;
		margin-right: 1%;
		padding-right: 1%;
	}
	.content-primary ul:first-child {
		margin-top: 0;
	}
	.content-secondary h2 {
		position: absolute;
		left: -9999px;
	}
	.type-interior .content-primary {
		padding: 1.5em 6% 3em 0;
		margin: 0;
	}
	/* fix up the collapsibles - expanded on desktop */
	.content-secondary .ui-collapsible-heading {
		display: none;
	}
	.content-secondary .ui-collapsible-contain {
		margin:0;
	}
	.content-secondary .ui-collapsible-content {
		display: block;
		margin: 0;
		padding: 0;
	}
	.type-interior  .content-secondary .ui-li-divider {
		padding-top: 1em;
		padding-bottom: 1em;
	}
	.type-interior .content-secondary {
		margin: 0;
		padding: 0;
	}
	
}
@media all and (min-width: 750px){
	.type-interior .ui-content {
		background-position: 39%;
	}
	.content-secondary {
		width: 34%;
	}
	.content-primary {
		width: 56%;
		padding-right: 1%;
	}	
	.type-interior .ui-content {
		background-position: 34%;
	}
}

@media all and (min-width: 1200px){
	.type-interior .ui-content {
		background-position: 30%;
	}
	.content-secondary {
		width: 30%;
		padding-right:6%;
		margin: 30px 0 20px 5%;
	}
	.type-interior .content-secondary {
		margin: 0;
		padding: 0;
	}
	.content-primary {
		width: 50%;
		margin-right: 5%;
		padding-right: 3%;
	}
	.type-interior .content-primary {
		width: 60%;
	}
}'! !

!PRJqmFileLibrary methodsFor: 'accessing' stamp: 'YanniChiu 12/7/2011 14:04'!
selectorsToInclude
	^ #( prJQueryMobileCss )! !

MAComponentRenderer subclass: #PRJqmFormRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmFormRenderer commentStamp: 'YanniChiu 12/8/2011 01:38' prior: 0!
A PRJqmFormRenderer is a Magritte component renderer customized for JQueryMobile.
!

!PRJqmFormRenderer methodsFor: 'rendering' stamp: 'YanniChiu 11/2/2011 22:38'!
renderContainer: aDescription
	html unorderedList
		jqmListView;
		with: [ super renderContainer: aDescription ]! !

!PRJqmFormRenderer methodsFor: 'rendering' stamp: 'YanniChiu 11/3/2011 16:53'!
renderControl: aDescription
	aDescription kind = Boolean
		ifTrue: [ | aBooleanComponent |
			aBooleanComponent := self childAt: aDescription.
			html checkbox
				id: aBooleanComponent labelId;
				disabled: aBooleanComponent isReadonly;
				on: #value of: aBooleanComponent
		]
		ifFalse: [ super renderControl: aDescription ]! !

!PRJqmFormRenderer methodsFor: 'rendering' stamp: 'YanniChiu 11/2/2011 22:46'!
renderElement: aDescription
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
	html listItem with: [
		html div
			jqmFieldContainer;
			with: [
				self renderLabel: aDescription.
				self renderControl: aDescription ] ]! !

!PRJqmFormRenderer methodsFor: 'rendering' stamp: 'YanniChiu 11/3/2011 16:48'!
renderLabel: aDescription
	"Same as super method, but '*' character to required fields"
	| label |
	aDescription hasLabel ifFalse: [ ^ self ].
	label := html label.
	(self hasError: aDescription)
		ifTrue: [ label class: 'error' ].
	(self childAt: aDescription) hasLabelId
		ifTrue: [ label for: (self childAt: aDescription) labelId ].
	label with: [
		html render: aDescription label.
		aDescription isRequired ifTrue: [ html text: '*' ]
	]! !

!PREmbeddedRenderer methodsFor: '*pier-jquerymobile-core' stamp: 'YanniChiu 12/8/2011 00:41'!
visitPageJQueryMobile: aPage parameter: parm
	| visitor |
	visitor := PRMostSpecificInternalLinkVisitor new.
	visitor visit: aPage document.
	parent structure: aPage during: [
		(parm = 'navbar' ifTrue: [ PRJqmNavbarRenderer ] ifFalse: [ PRJqmListRenderer ]) new
			heading: aPage title;
			copyFrom: parent;
			continue: aPage document
			in: aPage on: html ]! !

PRViewRenderer subclass: #PRJqmListRenderer
	instanceVariableNames: 'heading'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmListRenderer commentStamp: 'YanniChiu 12/8/2011 00:43' prior: 0!
A PRJqmListRenderer renders a Pier list as a JQueryMobile list.
!

!PRJqmListRenderer methodsFor: 'accessing' stamp: 'YanniChiu 10/18/2011 17:39'!
heading

	^ heading isNil ifTrue: [ 'Menu' ] ifFalse: [ heading ].! !

!PRJqmListRenderer methodsFor: 'accessing' stamp: 'YanniChiu 10/18/2011 17:22'!
heading: anObject

	heading := anObject! !

!PRJqmListRenderer methodsFor: 'visiting-document' stamp: 'YanniChiu 11/5/2011 02:01'!
visitListItem: anObject
	| listItem |
	listItem := html listItem.
	anObject children detect: [ :e | e isLink ] ifNone: [ listItem jqmListDivider ].
	listItem with: [ super visitDocumentGroup: anObject ]! !

!PRJqmListRenderer methodsFor: 'visiting-document' stamp: 'YanniChiu 11/5/2011 02:03'!
visitOrderedList: anObject
	"html div
		jqmCollapsible;
		with: [
			html heading
				level1;
				with: ' '."
			html unorderedList
				jqmListView;
				with: [ super visitList: anObject ] "]"! !

!PRJqmListRenderer methodsFor: 'visiting-document' stamp: 'YanniChiu 11/5/2011 02:03'!
visitUnorderedList: anObject
	"html div
		jqmCollapsible;
		with: [
			html heading
				level1;
				with: 'Menu'."
			html unorderedList
				jqmListView;
				with: [ super visitList: anObject ] "]"! !

PRViewRenderer subclass: #PRJqmNavbarRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmNavbarRenderer commentStamp: 'YanniChiu 12/8/2011 00:43' prior: 0!
A PRJqmNavbarRenderer renders a Pier list as a JQueryMobile navbar.
!

!PRJqmNavbarRenderer methodsFor: 'accessing' stamp: 'YanniChiu 11/5/2011 01:35'!
heading
	"Do nothing"! !

!PRJqmNavbarRenderer methodsFor: 'accessing' stamp: 'YanniChiu 11/5/2011 01:35'!
heading: ignore
	"Do nothing"! !

!PRJqmNavbarRenderer methodsFor: 'visiting-document' stamp: 'YanniChiu 11/5/2011 01:07'!
visitOrderedList: anObject
	html div
		jqmRole: 'navbar';
		with: [
			html orderedList
				jqmListView;
				with: [ super visitList: anObject ] ]! !

!PRJqmNavbarRenderer methodsFor: 'visiting-document' stamp: 'YanniChiu 11/5/2011 01:06'!
visitUnorderedList: anObject
	html div
		jqmRole: 'navbar';
		with: [
			html unorderedList
				jqmListView;
				with: [ super visitList: anObject ] ]! !

PRListWidget subclass: #PRJqmListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmListWidget commentStamp: 'YanniChiu 12/8/2011 00:06' prior: 0!
A PRJqmListWidget is an abstract class for some common code shared by subclasses.
!

PRJqmListWidget subclass: #PRJqmCommandsWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmCommandsWidget commentStamp: 'YanniChiu 12/8/2011 00:05' prior: 0!
A PRJqmCommandsWidget is a modified copy of PRCommandsWidget, adjusted for use with JQueryMobile.
!

!PRJqmCommandsWidget class methodsFor: 'accessing-defaults' stamp: 'YanniChiu 10/20/2011 22:09'!
defaultCommandClasses
	^ (Array withAll: PRCommand withAllConcreteClasses)
		sort: [ :a :b | a label caseInsensitiveLessOrEqual: b label ];
		yourself! !

!PRJqmCommandsWidget class methodsFor: 'accessing-description' stamp: 'YanniChiu 10/20/2011 22:09'!
descriptionCommandClasses
	^ MAMultipleOptionDescription new
		default: [ self defaultCommandClasses ] magritteDynamicObject;
		options: [ self defaultCommandClasses ] magritteDynamicObject;
		componentClass: MAListCompositonComponent;
		reference: MAClassDescription new;
		accessor: #commandClasses;
		label: 'Command Classes';
		priority: 200;
		beOrdered;
		beDistinct;
		beSorted;
		yourself! !

!PRJqmCommandsWidget class methodsFor: 'testing' stamp: 'YanniChiu 10/20/2011 22:09'!
isAbstract
	^ false! !

!PRJqmCommandsWidget class methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:09'!
label
	^ 'Commands'! !

!PRJqmCommandsWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:09'!
collapsedTitle
	^ 'Commands'! !

!PRJqmCommandsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:09'!
commandClasses
	^ self read: #descriptionCommandClasses! !

!PRJqmCommandsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:09'!
items
	| commands |
	commands := self context commands.
	^ self commandClasses select: [ :each | commands includes: each ]! !

!PRJqmCommandsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:09'!
labelFor: anObject
	^ anObject shortLabel! !

!PRJqmCommandsWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:09'!
renderContentOn: html
	| items |
	items := self items.
	items isEmpty
		ifFalse: [ self jqmRenderItems: items on: html ]! !

!PRJqmCommandsWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:09'!
renderItem: aClass on: html
	html anchor
		class: 'active' if: (self isActive: aClass);
		accessKey: aClass accessKey;
		goto: (self context
			structure: self context structure
			command: aClass new);
		with: (self labelFor: aClass)! !

!PRJqmCommandsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:09'!
selected
	^ self context command class! !

!PRJqmListWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:08'!
collapsedTitle
	^ self subclassResponsibility! !

!PRJqmListWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:08'!
jqmRenderItems: aCollection on: html
	"html div
		jqmCollapsible;
		with: [
			html heading
				level3;
				with: self collapsedTitle."
			html unorderedList
				jqmListView
				with: [
					html listItem
						jqmListDivider;
						with: self collapsedTitle.
					aCollection do: [ :each |
						html listItem: [
							self renderItem: each on: html ] ] ] "]"! !

PRJqmListWidget subclass: #PRJqmViewsWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRJqmViewsWidget commentStamp: 'YanniChiu 12/8/2011 00:04' prior: 0!
A PRJqmViewsWidget is a modified copy of PRViewsWidget, adjusted for use with JQueryMobile.
!

!PRJqmViewsWidget class methodsFor: 'accessing-default' stamp: 'YanniChiu 10/20/2011 22:10'!
defaultViewClasses
	^ ((Array withAll: PRViewComponent withAllConcreteClasses)
		select: [ :each | each isListed ])
		sort: [ :a :b | a label caseInsensitiveLessOrEqual: b label ];
		yourself! !

!PRJqmViewsWidget class methodsFor: 'accessing-description' stamp: 'YanniChiu 10/20/2011 22:10'!
descriptionViewClasses
	^ MAMultipleOptionDescription new
		default: [ self defaultViewClasses ] magritteDynamicObject;
		options: [ self defaultViewClasses ] magritteDynamicObject;
		componentClass: MAListCompositonComponent;
		reference: MAClassDescription new;
		accessor: #viewClasses;
		label: 'View Classes';
		priority: 200;
		beOrdered;
		beDistinct;
		beSorted;
		yourself! !

!PRJqmViewsWidget class methodsFor: 'testing' stamp: 'YanniChiu 10/20/2011 22:10'!
isAbstract
	^ false! !

!PRJqmViewsWidget class methodsFor: 'converting' stamp: 'YanniChiu 10/20/2011 22:10'!
label
	^ 'Views'! !

!PRJqmViewsWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:10'!
collapsedTitle
	^ 'Views'! !

!PRJqmViewsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:10'!
items
	| views |
	views := self context views.
	^ self viewClasses select: [ :each | views includes: each ]! !

!PRJqmViewsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:10'!
labelFor: anObject
	^ anObject label! !

!PRJqmViewsWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:10'!
renderContentOn: html
	| items |
	items := self items.
	items isEmpty
		ifFalse: [ self jqmRenderItems: items on: html ]! !

!PRJqmViewsWidget methodsFor: 'rendering' stamp: 'YanniChiu 10/20/2011 22:10'!
renderItem: aClass on: html
	html anchor
		title: aClass label;
		class: 'active' if: (self isActive: aClass);
		goto: (self context view: aClass);
		with: (self labelFor: aClass)! !

!PRJqmViewsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:10'!
selected
	^ self context command isView
		ifTrue: [ self context command viewComponent class ]! !

!PRJqmViewsWidget methodsFor: 'accessing' stamp: 'YanniChiu 10/20/2011 22:10'!
viewClasses
	^ self read: #descriptionViewClasses! !

PRWidget subclass: #PRAuthenticationWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-JQueryMobile-Core'!

!PRAuthenticationWidget commentStamp: 'YanniChiu 12/8/2011 00:10' prior: 0!
A PRAuthenticationWidget is a login/logout widget for the JQueryMobile interface of Pier.
!

!PRAuthenticationWidget class methodsFor: 'testing' stamp: 'YanniChiu 6/29/2010 12:55'!
isAbstract
	^ false! !

!PRAuthenticationWidget class methodsFor: 'accessing' stamp: 'YanniChiu 1/31/2011 17:11'!
label
	^ 'Authentication'! !

!PRAuthenticationWidget methodsFor: 'rendering' stamp: 'YanniChiu 6/29/2010 12:55'!
labelFor: anObject
	^ anObject shortLabel! !

!PRAuthenticationWidget methodsFor: 'rendering' stamp: 'YanniChiu 11/10/2011 00:02'!
renderContentOn: html
	| user |
	user := self context user.
	user isNil
		ifTrue: [ 
			(html anchor)
				class: 'ui-btn-right';
				goto: (self context command: PULogin new);
				with: 'Login' ]
		ifFalse: [ 
			(html anchor)
				class: 'ui-btn-right';
				goto: (self context command: PULogout new);
				with: user name, ' - Logout' ]! !

!PRAuthenticationWidget methodsFor: 'rendering' stamp: 'YanniChiu 6/29/2010 14:25'!
renderItem: aClass on: html
	html anchor
		accessKey: aClass accessKey;
		goto: (self context
			structure: self context structure
			command: aClass new);
		with: (self labelFor: aClass)! !
